Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DateValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.DateValue

All Implemented Interfaces:
  java.lang.Comparable, Expression, Item, java.io.Serializable, ValueRepresentation

Direct Known Subclasses:
  GDayValue, GMonthDayValue, GMonthValue, GYearMonthValue, GYearValue

public class DateValue
extends CalendarValue

A value of type Date. Note that a Date may include a TimeZone.

See Also:
  Serialized Form

Field Summary
`protected byte` | `day`
`protected byte` | `month`
`protected int` | `year`

Fields inherited from class net.sf.saxon.value.CalendarValue
`NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`protected` | `DateValue()` Default constructor needed for subtyping
`` | `DateValue(java.lang.CharSequence s)` Constructor: create a dateTime value from a supplied string, in ISO 8601 format
`` | `DateValue(java.util.GregorianCalendar calendar, int tz)` Create a DateValue
`` | `DateValue(int year, byte month, byte day)` Constructor given a year, month, and day.
`` | `DateValue(int year, byte month, byte day, int tz)` Constructor given a year, month, and day, and timezone.

Method Summary
`CalendarValue` | `add(DurationValue duration)` Add a duration to a date
`CalendarValue` | `adjustTimezone(int timezone)` Return a new date with the same normalized value, but in a different timezone.
`int` | `compareTo(CalendarValue other, XPathContext context)` Compare this value to another value of the same type, using the supplied context object to get the implicit timezone if required.
`int` | `compareTo(java.lang.Object other)` Compare the value to another date value.
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`java.lang.Object` | `convertToJava(java.lang.Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`CalendarValue` | `copy()` Make a copy of this date, time, or dateTime value
`static DateValue` | `dateFromJulianDayNumber(int julianDayNumber)` Get the Gregorian date corresponding to a particular Julian day number.
`boolean` | `equals(java.lang.Object other)` Compare two (sequence) values for equality.
`java.util.GregorianCalendar` | `getCalendar()` Get a Java Calendar object that represents this date/time value.
`AtomicValue` | `getComponent(int component)` Get a component of the value.
`byte` | `getDay()` Get the day component of the date (in local form)
`static int` | `getDayOfWeek(int year, int month, int day)` Get the day of the week.
`static int` | `getDayWithinYear(int year, int month, int day)` Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression
`static int` | `getJulianDayNumber(int year, int month, int day)` Calculate the Julian day number at 00:00 on a given date.
`byte` | `getMonth()` Get the month component of the date (in local form)
`java.lang.CharSequence` | `getStringValueCS()` Convert to string
`static int` | `getWeekNumber(int year, int month, int day)` Get the ISO week number for a given date.
`static int` | `getWeekNumberWithinMonth(int year, int month, int day)` Get the week number within a month.
`int` | `getYear()` Get the year component of the date (in local form)
`int` | `hashCode()` Return a hash code to support the equals() function
`static boolean` | `isLeapYear(int year)` Test whether a year is a leap year
`static boolean` | `isValidDate(int year, int month, int day)`
`static void` | `main(java.lang.String[] args)` Temporary test rig
`void` | `setLexicalValue(java.lang.CharSequence s)` Initialize the DateValue using a character string in the format yyyy-mm-dd and an optional time zone.
`SecondsDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`DateTimeValue` | `toDateTime()` Convert to DateTime
`static DateValue` | `tomorrow(int year, byte month, byte day)` Get the date that immediately follows a given date
`static DateValue` | `yesterday(int year, byte month, byte day)` Get the date that immediately precedes a given date

Methods inherited from class net.sf.saxon.value.CalendarValue
`appendTimezone, appendTimezone, getStringValue, getTimezoneInMinutes, hasTimezone, removeTimezone, setTimezoneInMinutes`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, display, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getImplementationMethod, getLength, getPrimitiveValue, getTypedValue, hasBuiltInType, iterate, process, schemaEquals, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, getDependencies, getIterator, getParentExpression, getSpecialProperties, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, reduce, simplify, stringToNumber, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### year

    protected int year

### month

    protected byte month

### day

    protected byte day

Constructor Detail

### DateValue

    protected DateValue()

  Default constructor needed for subtyping

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day)

  Constructor given a year, month, and day. Performs no validation.

Parameters:
  `year` - The year as held internally (note that the year before 1AD is 0)
  `month` - The month, 1-12
  `day` - The day 1-31

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     int tz)

  Constructor given a year, month, and day, and timezone. Performs no validation.

Parameters:
  `year` - The year as held internally (note that the year before 1AD is 0)
  `month` - The month, 1-12
  `day` - The day 1-31
  `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.

### DateValue

    public DateValue(java.lang.CharSequence s)
              throws XPathException

  Constructor: create a dateTime value from a supplied string, in ISO 8601 format

### DateValue

    public DateValue(java.util.GregorianCalendar calendar,
                     int tz)

  Create a DateValue

Parameters:
  `calendar` - the absolute date/time value
  `tz` - The timezone offset from GMT in minutes, positive or negative; or the special value NO_TIMEZONE indicating that the value is not in a timezone

Method Detail

### setLexicalValue

    public void setLexicalValue(java.lang.CharSequence s)
                         throws XPathException

  Initialize the DateValue using a character string in the format yyyy-mm-dd and an optional time zone. Input must have format [-]yyyy-mm-dd[([+|-]hh:mm | Z)]

  Parameters:
    `s` - the supplied string value
  Throws:
    `XPathException`

### getYear

    public int getYear()

  Get the year component of the date (in local form)

### getMonth

    public byte getMonth()

  Get the month component of the date (in local form)

### getDay

    public byte getDay()

  Get the day component of the date (in local form)

### isValidDate

    public static boolean isValidDate(int year,
                                      int month,
                                      int day)

### isLeapYear

    public static boolean isLeapYear(int year)

  Test whether a year is a leap year

### tomorrow

    public static DateValue tomorrow(int year,
                                     byte month,
                                     byte day)

  Get the date that immediately follows a given date

  Returns:
    a new DateValue with no timezone information

### yesterday

    public static DateValue yesterday(int year,
                                      byte month,
                                      byte day)

  Get the date that immediately precedes a given date

  Returns:
    a new DateValue with no timezone information

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### toDateTime

    public DateTimeValue toDateTime()

  Convert to DateTime

  Specified by:
    `toDateTime` in class `CalendarValue`

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Convert to string

  Specified by:
    `getStringValueCS` in interface `Item`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    ISO 8601 representation.

### getCalendar

    public java.util.GregorianCalendar getCalendar()

  Description copied from class: `CalendarValue`
  Get a Java Calendar object that represents this date/time value. The Calendar object will be newly created for the purpose

  Specified by:
    `getCalendar` in class `CalendarValue`
  Returns:
    A Calendar object representing the date and time. Note that Java can only represent the time to millisecond precision, and that it does not support the full range of timezones required by XPath (-14:00 to +14:00)

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Value`
  Parameters:
    `th` -
  Returns:
    Type.DATE_TYPE,

### copy

    public CalendarValue copy()

  Make a copy of this date, time, or dateTime value

  Specified by:
    `copy` in class `CalendarValue`

### adjustTimezone

    public CalendarValue adjustTimezone(int timezone)

  Return a new date with the same normalized value, but in a different timezone. This is called only for a DateValue that has an explicit timezone

  Specified by:
    `adjustTimezone` in class `CalendarValue`
  Parameters:
    `timezone` - the new timezone offset, in minutes
  Returns:
    the time in the new timezone. This will be a new TimeValue unless no change was required to the original value

### convertToJava

    public java.lang.Object convertToJava(java.lang.Class target,
                                          XPathContext context)
                                   throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
  Throws:
    `XPathException`

### compareTo

    public int compareTo(java.lang.Object other)

  Compare the value to another date value. This method is used only during schema processing, and uses XML Schema semantics rather than XPath semantics.

  Parameters:
    `other` - The other date value. Must be an object of class DateValue.
  Returns:
    negative value if this one is the earlier, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `java.lang.ClassCastException` - if the other value is not a DateValue (the parameter is declared as Object to satisfy the Comparable interface)

### compareTo

    public int compareTo(CalendarValue other,
                         XPathContext context)

  Compare this value to another value of the same type, using the supplied context object to get the implicit timezone if required. This method implements the XPath comparison semantics.

  Specified by:
    `compareTo` in class `CalendarValue`

### equals

    public boolean equals(java.lang.Object other)

  Description copied from class: `Value`
  Compare two (sequence) values for equality. This supports identity constraints in XML Schema, which allow list-valued elements and attributes to participate in key and uniqueness constraints. This method returns false if any error occurs during the comparison, or if any of the items in either sequence is a node rather than an atomic value.

  Overrides:
    `equals` in class `Value`

### hashCode

    public int hashCode()

  Description copied from class: `Value`
  Return a hash code to support the equals() function

  Overrides:
    `hashCode` in class `Value`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a date

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public SecondsDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` -
  Returns:
    the duration as an xdt:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

### getJulianDayNumber

    public static int getJulianDayNumber(int year,
                                         int month,
                                         int day)

  Calculate the Julian day number at 00:00 on a given date. This algorithm is taken from http://vsg.cape.com/~pbaum/date/jdalg.htm and http://vsg.cape.com/~pbaum/date/jdalg2.htm (adjusted to handle BC dates correctly)

### dateFromJulianDayNumber

    public static DateValue dateFromJulianDayNumber(int julianDayNumber)

  Get the Gregorian date corresponding to a particular Julian day number. The algorithm is taken from http://www.hermetic.ch/cal_stud/jdn.htm#comp

  Returns:
    a DateValue with no timezone information set

### getDayWithinYear

    public static final int getDayWithinYear(int year,
                                             int month,
                                             int day)

  Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)

### getDayOfWeek

    public static final int getDayOfWeek(int year,
                                         int month,
                                         int day)

  Get the day of the week. The days of the week are numbered from 1 (Monday) to 7 (Sunday)

### getWeekNumber

    public static final int getWeekNumber(int year,
                                          int month,
                                          int day)

  Get the ISO week number for a given date. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and week 1 in any calendar year is the week (from Monday to Sunday) that includes the first Thursday of that year

### getWeekNumberWithinMonth

    public static final int getWeekNumberWithinMonth(int year,
                                                     int month,
                                                     int day)

  Get the week number within a month. This is required for the XSLT format-date() function, and the rules are not entirely clear. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and by analogy with the ISO week number, we consider that week 1 in any calendar month is the week (from Monday to Sunday) that includes the first Thursday of that month. Unlike the ISO week number, we put the previous days in week zero.

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Temporary test rig

  Throws:
    `java.lang.Exception`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD